Summary: A kernel interface to the pvfs layer
Name: pvfs-kernel
Version: 0.9.1
Release: 2_%(uname -r | tr - _ )
Copyright: GPL
Group: System Environment/Base
Source: ftp://ftp.parl.clemson.edu/pub/pvfs/pvfs-kernel-%{version}.tgz
Source1: pvfs-kernel-%{version}-pvfsd.rc
Requires: pvfs

BuildRoot: /var/tmp/%{name}-buildroot

%description
PVFS is a parallel file system for linux.  This kernel module provides
the ability to mount and interact with a PVFS file system using standard
system utilities.

A kernel module, this must be rebuilt whenever the kernel changes.

%prep
%setup -q 

%build
# i'm giving no flags, because i'll skip the "make install" command
./configure
make

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p ${RPM_BUILD_ROOT}/lib/modules/`uname -r`/fs
cp pvfs.o ${RPM_BUILD_ROOT}/lib/modules/`uname -r`/fs

mkdir -p ${RPM_BUILD_ROOT}/usr/sbin
cp pvfsd ${RPM_BUILD_ROOT}/usr/sbin
mkdir -p ${RPM_BUILD_ROOT}/sbin
cp mount.pvfs ${RPM_BUILD_ROOT}/sbin

install -d ${RPM_BUILD_ROOT}/etc/rc.d/init.d
install -m 755 %{SOURCE1} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/pvfsd
%clean
rm -rf $RPM_BUILD_ROOT

%post
# only if not an upgrade
if [ $1 -eq 1 ]; then 
	# wow this is ugly: sometimes conf.modules is used, sometimes modules.conf. 
	MODCONF=/etc/conf.modules
	# if modules.conf exists, it will be used instead of conf.modules, so play along
	[ -e /etc/modules.conf ] && MODCONF=/etc/modules.conf
	# some module tricks:
	echo "alias char-major-60 pvfs" >> /etc/$MODCONF
	# mapped mode is better, but will fall back to dynamic if not avaliable
	echo "options pvfs buffer=mapped" >> /etc/$MODCONF
	# and make sure the changes take effect
	# really can't use a /dev/pvfsd with different major number
	/sbin/depmod -a
	rm -rf /dev/pvfsd && mknod /dev/pvfsd c 60 0
	/etc/rc.d/init.d/pvfsd start
	chkconfig --add pvfsd
fi

%preun
# only if not an upgrade
if [ $1 -eq 0 ]; then
	# undo our modules tricks
	MODCONF=/etc/conf.modules
	[ -e /etc/modules.conf ] && MODCONF=/etc/modules.conf
	perl -p -i -e "s/alias char-major-60 pvfs//" $MODCONF
	perl -p -i -e "s/options pvfs buffer=mapped//" $MODCONF
	rm -rf /dev/pvfsd
	chkconfig --del pvfsd
fi

%files
%defattr(-,root,root)
%doc README 

/lib/modules/*/fs/pvfs.o
/usr/sbin/pvfsd
/sbin/mount.pvfs
/etc/rc.d/init.d/pvfsd

%changelog
* Fri Apr 27 2001 Rob Latham <rlatham@plogic.com>
- updated for new version
- modify conf.modules to help automate the pvfs funstuff

* Wed Nov 15 2000 Rob Latham <rlatham@plogic.com>
- first rpmming of pvfs-kernel
